Description

The in place xml editing is not reliable, and it's impossible to include or exclude chunks of configuration settings.

Also, move the log files under tomcat/logs where they really belong.

Related issues:

Related to D4Science Infrastructure - Task #9942: Change the way to generate ... Closed Oct 12, 2017

History

#1 - Sep 02, 2017 05:24 PM - Andrea Dell'Amico

Also, add the following configuration on the dataminers (the log path will change):

<appender name="ANALYSIS"

                class="ch.qos.logback.core.rolling.RollingFileAppender">

                <file>/home/gcube/SmartGears/analysis.log</file>

                <append>true</append>

                <encoder>

                        <pattern>%d{HH:mm:ss.SSS} [%thread] %-5level %logger{0}: %msg%n

                        </pattern>

                </encoder>

                <rollingPolicy class="ch.qos.logback.core.rolling.TimeBasedRollingPolicy">

                        <fileNamePattern>/home/gcube/SmartGears/analysis.%d{yyyy-MM-dd}.log

                        </fileNamePattern>

                        <maxHistory>30</maxHistory>

                </rollingPolicy>

        </appender>

       <logger name="org.gcube.dataanalysis" level="DEBUG">

                <appender-ref ref="ANALYSIS" />

        </logger>

#2 - Sep 02, 2017 05:26 PM - Andrea Dell'Amico

Another parameter that can be configured is maxHistory: 30 days is usually too much.

#3 - Sep 02, 2017 05:27 PM - Andrea Dell'Amico

Last: if a size based rolling appender can be configured, this would be very helpful to keep the total log size under control.

#4 - Sep 02, 2017 05:29 PM - Andrea Dell'Amico

Since logback 1.1.7 there's an appender called SizeAndTimeBasedRollingPolicy that does exactly what I'm asking. A reference: 

https://logback.qos.ch/manual/appenders.html#SizeAndTimeBasedRollingPolicy

#5 - Sep 04, 2017 07:49 PM - Andrea Dell'Amico

- Status changed from New to In Progress

#6 - Sep 04, 2017 08:01 PM - Andrea Dell'Amico

- % Done changed from 0 to 80

I have a prototype that uses the new rolling policy and also sets a global cap.
https://logback.qos.ch/manual/appenders.html#SizeAndTimeBasedRollingPolicy


The log files will be moved into tomcat/logs too.

#7 - Sep 05, 2017 11:49 AM - Andrea Dell'Amico

@lucio.lelii@isti.cnr.it smartgear comes with logback 1.0.13 and it's too old to support the new rolling appender. We should upgrade to at least 1.1.7

#9 - Sep 05, 2017 12:40 PM - Andrea Dell'Amico

- Status changed from In Progress to Feedback

- % Done changed from 80 to 100

The new logback configuration has been installed on dataminer1-pre.d4science.org. @roberto.cirillo@isti.cnr.it @lucio.lelii@isti.cnr.it

@gianpaolo.coro@isti.cnr.it please review it. 

The SizeAndTimeBasedRollingPolicy will be enabled when a newer logback version will be available.

#10 - Sep 12, 2017 06:24 PM - Lucio Lelii

- Status changed from Feedback to In Progress

- Assignee changed from _InfraScience Systems Engineer to Lucio Lelii

- % Done changed from 100 to 80

I have tested the new logback version (1.1.11) that support SizeAndTimeBasedRollingPolicy.

I'm going to update the version on the smartgears distribution and release it in 4.7.

The appender configuration is not correct for this new version, you have to add the %i suffix to the fileNamePattern:

<fileNamePattern>/home/gcube/SmartGears/analysis.%d{yyyy-MM-dd}.%i.log

#11 - Sep 12, 2017 06:27 PM - Andrea Dell'Amico

Lucio Lelii wrote:

The appender configuration is not correct for this new version, you have to add the %i suffix to the fileNamePattern:

<fileNamePattern>/home/gcube/SmartGears/analysis.%d{yyyy-MM-dd}.%i.log

 

Done.

#12 - Nov 17, 2017 06:08 PM - Andrea Dell'Amico

- Status changed from In Progress to Closed

- Assignee changed from Lucio Lelii to Andrea Dell'Amico

- % Done changed from 80 to 100

#13 - Nov 17, 2017 06:10 PM - Andrea Dell'Amico

- Related to Task #9942: Change the way to generate the logback.xml in smartgears container added
